package com.ann.demo.repository.primary;

import com.ann.demo.entity.filing.ArchiveDetail;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;
import org.springframework.stereotype.Repository;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;
import java.util.Map;

/**
 * @Author: LeiJiaXin
 * @Date: 2019/7/12 9:10
 */
@Transactional
@Repository
public interface ArchiveDetailRepository extends JpaRepository<ArchiveDetail, String> {
    @Query(value = "SELECT stuff(" +
            "   (SELECT  ',' + CONVERT(VARCHAR,a.assort_name) " +
            "        FROM zd_assort a WHERE a.assort_id in ?1  " +
            "        and NOT EXISTS(SELECT id FROM archive_detail d WHERE  a.assort_id = d.AssortID  and  d.MasterID = ?2 ) " +
            "    FOR XML PATH ('') " +
            "    ),1,1,'') ", nativeQuery = true)
    String getTypeNotExits(List<String> type, String masterId);

    @Query(value = "select * from archive_detail where MasterID = ?1 \n" +
            "  and Source !='电子病历系统采集服务-长临医嘱' and Source !='扫描上传' and Source !='手工上传' and flag =0 and id not in\n" +
            "  (select DID from archive_other_ext where MID = ?1) ",nativeQuery = true)
    List<ArchiveDetail>getRepeatRecord(String mid);


    @Query(value = " SELECT stuff( " +
            "            ( select ',' +name+'缺失' + cast(COUNT(report_type) as varchar)+'份'  from exam_apply  e " +
            "            where  not exists (select 1 from archive_detail a where source <> '后台' and a.apply_id = e.apply_id and a.assortid in ?1  ) " +
            "             and exists (select 1 from archive_master  m " +
            "             where m.inp_no = e.inp_no and m.visit_id = e.visit_id and m.patient_id = e.patient_id and " +
            "             m.ID = ?2 ) " +
            "             and e.report_type in ?1 " +
            "             and e.is_valid = 0 and e.is_open_his  = 'E' and e.is_open_other = 'E' " +
            "             group by name " +
            "             FOR XML PATH ('')   " +
            "            ),1,1,'')", nativeQuery = true)
    String getCheckReportNotExits( List<String> type,String masterId);




    /**
     * 备份，如果检查申请单没有名称的，还是按照之前的查
     * */
    @Query(value = "SELECT stuff( " +
            "      ( select ',' +z.assort_name+'缺失' + cast(COUNT(report_type) as varchar)+'份'  from exam_apply  e , zd_assort z" +
            "       where z.assort_id = e.report_type and  not exists (select 1 from archive_detail a where source <> '后台' and a.apply_id = e.apply_id and a.assortid in ?1  ) " +
            "       and exists (select 1 from archive_master  m " +
            "       where m.inp_no = e.inp_no and m.visit_id = e.visit_id and m.patient_id = e.patient_id and " +
            "      m.ID = ?2 ) " +
            "      and e.report_type in ?1 " +
            "        and e.is_valid = 0 and e.is_open_his  = 'E' and e.is_open_other = 'E' " +
            "       group by z.assort_name " +
            "        FOR XML PATH ('')   " +
            "      ),1,1,'')", nativeQuery = true)
    String getCheckReportNotExits1( List<String> type,String masterId);

    @Query(value = "select pdf_path from archive_detail where MasterID in ( " +
            "select id from Archive_Master WHERE name = '刘钰'  ) and flag = 0 and AssortID in (9,113,10,54,57,59,52,30) " +
            "",nativeQuery = true)
    List<String> haha();


    /**
     * 备份，如果检验申请单没有名称的，还是按照之前的查
     * */
//    @Query(value = " select '检验报告缺失' +cast( (select isnull((select count(e.apply_id) from exam_apply e " +
//            " where e.report_type in ?1 and e.is_valid = 0 and e.is_open_his  = 'E' and e.is_open_other = 'E'  " +
//            "      and exists " +
//            "       (select 1 from archive_master  m where m.inp_no = e.inp_no and m.visit_id = e.visit_id and m.patient_id = e.patient_id " +
//            "      and m.ID = ?2 )  ),0) " +
//            " -" +
//            " isnull((select COUNT(*)  from  exam_apply e,archive_detail d " +
//            " where source <> '后台' and e.report_type in ?1 and d.AssortID = ?1 and e.is_valid = 0 and e.is_open_his  = 'E' and e.is_open_other = 'E' " +
//            " and masterid = ?2 " +
//            " and  charindex( e.apply_id,d.apply_id ) > 0),0) )as varchar)+'份' ",nativeQuery = true)
//    String  getInspectionReportNotExits(List<String> type,String masterId);


//    @Query(value = " select e.apply_id as applyId,e.name from  exam_apply e,archive_detail d  " +
//            "            where  e.report_type in ?1 and d.AssortID in ?1 and e.is_valid = 0 and e.is_open_his  = 'E' and e.is_open_other = 'E'  " +
//            "            and masterid = ?2  and d.flag = 0 " +
//            "            and  charindex( e.apply_id,d.apply_id ) > 0 ",nativeQuery = true)
//    List<Map<Object, Object>>  getInspectionApply(List<String> type,String masterId);

    @Query(value = " select apply_id from archive_detail d  where" +
            "            d.AssortID in ?1" +
            "            and masterid = ?2 " +
            "            and d.flag = 0 and source <> '后台' ",nativeQuery = true)
    List<String> getInspectionApply(List<String> type,String masterId);



    @Query(value = " select e.apply_id as applyId,e.name from exam_apply e " +
            "            where e.report_type in ?1 and e.is_valid = 0 and e.is_open_his  = 'E' and e.is_open_other = 'E'  " +
            "                 and exists " +
            "                  (select 1 from archive_master  m where m.inp_no = e.inp_no and m.visit_id = e.visit_id  " +
            "                  and m.patient_id = e.patient_id " +
            "                 and m.ID = ?2) ",nativeQuery = true)
    List<Map<Object, Object>>  getAllInspectionApply(List<String> type, String masterId);
}

