package com.ann.demo.service.impl;

import com.ann.demo.entity.filing.ArchiveDetail;
import com.ann.demo.entity.filing.ExamApplyDto;
import com.ann.demo.repository.primary.ArchiveDetailRepository;
import com.ann.demo.service.ArchiveDetailService;
import com.ann.demo.util.MapObjUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.*;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

/**
 * @Author: LeiJiaXin
 * @Date: 2019/7/12 9:12
 */
@Service
public class ArchiveDetailServiceImpl implements ArchiveDetailService {

    @Autowired
    ArchiveDetailRepository archiveDetailRepository;


    @Override
    public String getTypeNotExits(List<String> type, String masterId) {
        return archiveDetailRepository.getTypeNotExits(type, masterId);
    }

    @Override
    public String getCheckReportNotExits(List<String> type,String masterId) {
        return archiveDetailRepository.getCheckReportNotExits( type,masterId);
    }

    @Override
    public String getInspectionReportNotExits1(List<String> type,String masterId) {
        String result = null;
        // 1、查出所有的检验申请单
        List<Map<Object, Object>> examAllTempList = archiveDetailRepository.getAllInspectionApply(type, masterId);
        if (examAllTempList == null || examAllTempList.isEmpty()){
            return null;
        }
        //转成对应的集合
        List<ExamApplyDto> examAllList = new ArrayList<ExamApplyDto>();
        for (Map<Object, Object> map: examAllTempList){
            ExamApplyDto  messageLogDto = MapObjUtil.map2Object(map,ExamApplyDto.class);
            examAllList.add(messageLogDto);
        }
        // 2、查出所有的detail
        List<String> applyIdTempList = archiveDetailRepository.getInspectionApply(type, masterId);
        // 3、进行匹配
        List<ExamApplyDto> resultList = new ArrayList<ExamApplyDto>(examAllList);
        for (ExamApplyDto examApplyDto:examAllList) {
            for (String applyId: applyIdTempList){
                Pattern pattern = Pattern.compile(examApplyDto.getApplyId());
                Matcher matcher = pattern.matcher(applyId);
                if(matcher.find()){
                    resultList.remove(examApplyDto);
                }
            }
        }
        // 4、统计集合里元素相同的名称及数量
        Map<String, Integer> map = new HashMap<String, Integer>();
        for(ExamApplyDto examApplyDto:
                resultList){
            String name = examApplyDto.getName() ==null ? "检验报告":examApplyDto.getName();
            if(map.containsKey(name)){
                map.put(name, map.get(name).intValue() + 1);
            }else{
                map.put(name, new Integer(1));
            }
        }
        // 5、开始拼装
        Iterator<String> keys = map.keySet().iterator();
        StringBuffer sb=new StringBuffer();
        while(keys.hasNext()){
            String key = keys.next();
            int i = map.get(key).intValue();
            sb.append(key + "缺失" + map.get(key).intValue()  + "份, ");
        }
        if(sb.length() > 0){
            result = sb.substring(0,sb.length()-2);
        }
        return result;
    }

    @Override
    public String getRepeatRecord(String mid) {
        String result = null;
        List<ArchiveDetail> repeatRecord = archiveDetailRepository.getRepeatRecord(mid);
        Map<String, Integer> map = new HashMap<>();
        repeatRecord.forEach(item ->{
            String name = item.getTitle();
            if(map.containsKey(name)){
                map.put(name,map.get(name).intValue()+1);
            }else{
                map.put(name,new Integer(1));
            }
        });
        Iterator<String> keys = map.keySet().iterator();
        StringBuffer sb=new StringBuffer();
        while(keys.hasNext()){
            String key = keys.next();
            sb.append(key + "重复" + map.get(key).intValue()  + "份, ");
        }
        if(sb.length() > 0){
            result = sb.substring(0,sb.length()-2);
        }
        return  result;
    }

//    @Override
//    public String getInspectionReportNotExits(List<String> type,String masterId) {
//        return archiveDetailRepository.getInspectionReportNotExits( type,masterId);
//    }

    @Override
    public String getCheckReportNotExits1(List<String> types, String masterId) {
        return archiveDetailRepository.getCheckReportNotExits1( types,masterId);
    }

}





//        List<Map<Object, Object>> examAndDetailTempList = archiveDetailRepository.getInspectionApply(type, masterId);
//        if (examAndDetailTempList == null || examAndDetailTempList.isEmpty()){
//            return null;
//        }
//        //转换成对应的集合
//        List<ExamApplyDto> examAndDetailList = new ArrayList<ExamApplyDto>();
//        for (Map<Object, Object> map: examAndDetailTempList){
//            ExamApplyDto  examApplyDto = MapObjUtil.map2Object(map,ExamApplyDto.class);
//            examAndDetailList.add(examApplyDto);
//        }
//
//
//
//
//        // 3、取出两个集合的交集
//        for (ExamApplyDto examApplyDto : examAndDetailList) {
//            if (examAllList.contains(examApplyDto)) {
//                examAllList.remove(examApplyDto);
//            }
//        }
